summaryrefslogtreecommitdiff
path: root/eclass/mono.eclass
diff options
context:
space:
mode:
authorV3n3RiX <venerix@redcorelinux.org>2017-10-09 18:53:29 +0100
committerV3n3RiX <venerix@redcorelinux.org>2017-10-09 18:53:29 +0100
commit4f2d7949f03e1c198bc888f2d05f421d35c57e21 (patch)
treeba5f07bf3f9d22d82e54a462313f5d244036c768 /eclass/mono.eclass
reinit the tree, so we can have metadata
Diffstat (limited to 'eclass/mono.eclass')
-rw-r--r--eclass/mono.eclass80
1 files changed, 80 insertions, 0 deletions
diff --git a/eclass/mono.eclass b/eclass/mono.eclass
new file mode 100644
index 000000000000..913c04c85c70
--- /dev/null
+++ b/eclass/mono.eclass
@@ -0,0 +1,80 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+# @ECLASS: mono.eclass
+# @MAINTAINER:
+# dotnet@gentoo.org
+# @BLURB: common settings and functions for mono and dotnet related packages
+# @DESCRIPTION:
+# The mono eclass contains common environment settings that are useful for
+# dotnet packages. Currently, it provides no functions, just exports
+# MONO_SHARED_DIR and sets LC_ALL in order to prevent errors during compilation
+# of dotnet packages.
+
+inherit multilib
+
+# >=mono-0.92 versions using mcs -pkg:foo-sharp require shared memory, so we set the
+# shared dir to ${T} so that ${T}/.wapi can be used during the install process.
+export MONO_SHARED_DIR="${T}"
+
+# Building mono, nant and many other dotnet packages is known to fail if LC_ALL
+# variable is not set to C. To prevent this all mono related packages will be
+# build with LC_ALL=C (see bugs #146424, #149817)
+export LC_ALL=C
+
+# Monodevelop-using applications need this to be set or they will try to create config
+# files in the user's ~ dir.
+
+export XDG_CONFIG_HOME="${T}"
+
+# Fix bug 83020:
+# "Access Violations Arise When Emerging Mono-Related Packages with MONO_AOT_CACHE"
+
+unset MONO_AOT_CACHE
+
+egacinstall() {
+ use !prefix && has "${EAPI:-0}" 0 1 2 && ED="${D}"
+ gacutil -i "${1}" \
+ -root "${ED}"/usr/$(get_libdir) \
+ -gacdir /usr/$(get_libdir) \
+ -package ${2:-${GACPN:-${PN}}} \
+ || die "installing ${1} into the Global Assembly Cache failed"
+}
+
+mono_multilib_comply() {
+ use !prefix && has "${EAPI:-0}" 0 1 2 && ED="${D}"
+ local dir finddirs=() mv_command=${mv_command:-mv}
+ if [[ -d "${ED}/usr/lib" && "$(get_libdir)" != "lib" ]]
+ then
+ if ! [[ -d "${ED}"/usr/"$(get_libdir)" ]]
+ then
+ mkdir "${ED}"/usr/"$(get_libdir)" || die "Couldn't mkdir ${ED}/usr/$(get_libdir)"
+ fi
+ ${mv_command} "${ED}"/usr/lib/* "${ED}"/usr/"$(get_libdir)"/ || die "Moving files into correct libdir failed"
+ rm -rf "${ED}"/usr/lib
+ for dir in "${ED}"/usr/"$(get_libdir)"/pkgconfig "${ED}"/usr/share/pkgconfig
+ do
+
+ if [[ -d "${dir}" && "$(find "${dir}" -name '*.pc')" != "" ]]
+ then
+ pushd "${dir}" &> /dev/null
+ sed -i -r -e 's:/(lib)([^a-zA-Z0-9]|$):/'"$(get_libdir)"'\2:g' \
+ *.pc \
+ || die "Sedding some sense into pkgconfig files failed."
+ popd "${dir}" &> /dev/null
+ fi
+ done
+ if [[ -d "${ED}/usr/bin" ]]
+ then
+ for exe in "${ED}/usr/bin"/*
+ do
+ if [[ "$(file "${exe}")" == *"shell script text"* ]]
+ then
+ sed -r -i -e ":/lib(/|$): s:/lib(/|$):/$(get_libdir)\1:" \
+ "${exe}" || die "Sedding some sense into ${exe} failed"
+ fi
+ done
+ fi
+
+ fi
+}